#ifndef _P1_CAMERA_SDK_COMMON_EXCEPTIONS_H
#define _P1_CAMERA_SDK_COMMON_EXCEPTIONS_H

#include "C_P1CameraCommonErrorCodes.h"
#include "C_P1CameraCommonLinkage.h"
#include <stdexcept>

namespace P1
{
namespace CameraSdk
{
// Remove MSVC warning about exported class deviring from non-exported (STL) class
#ifdef _MSC_VER
#pragma warning (push)
#pragma warning (disable:4275)
#endif
    /**
    * @brief Base exception class for all exception thrown from the C++ API
    *
    * A child class would normally call this class' constructor to extract the human readable
    * error message string. This string is then provided to the default `std::exception` class.
    */
    class EXPORT_API SdkException : public std::runtime_error
    {
    public:
        SdkException(SdkException const& e2);	// Copy constructor - exceptions must have one such [C++ Standard, 15.1].
        SdkException(ErrorCode errorCode = kError);
        SdkException(char const* message, ErrorCode errorCode = kError);

        ErrorCode mErrorCode;
    };
#ifdef _MSC_VER
#pragma warning (pop)
#endif
} // CameraSdk
} // P1

#endif
